# er.sh from thowi
#
VERSION=50
ERKIT=er$VERSION.tar
#
INSTALLDIR=/var/tmp
#
# device specific variables
#
ERHOME=/usr/lib/enigma2/python/Plugins/Extensions/ER
# device paths
#
HELP=$ERHOME/readme.txt
PLUGINDIR=/usr/lib/enigma2/python/Plugins/Extensions
MEDIASERVER=$PLUGINDIR/Mediaserver7025/Mediaserver7025
MAKEKIT=$ERHOME/makekit.sh
ERSTART=/etc/rc3.d/S22mediaserver
ERDELTA=/usr/lib/enigma2/python/Plugins/Extensions/ER/.erdelta
ERDELTADEFAULT=2
#
BZIP2=/usr/bin/bzip2
DEBUG=$ERHOME/.erdebug
THINK=5


if [ -f $DEBUG ]; then
             echo "----------------------------------------------------"
#             echo $0 $1 $2 $3 $4 $5 $6
             wall "$0 $1 $2 $3 $4 $5 $6"
             echo "----------------------------------------------------"
#             exit 0
fi

if  [ ! -d $INSTALLDIR ]; then
        mkdir $INSTALLDIR
fi


cd /

case "$1" in
   "man")
      echo "-----------------------------------------------------"
      echo "Showing $HELP"
      echo "-----------------------------------------------------"
      cat $HELP
      echo "-----------------------------------------------------"
   ;;
   "log")
      echo "-----------------------------------------------------"
      echo "Display Logfile from last execution of" $0
#      echo "-----------------------------------------------------"
      if  [ ! -f $LOG ]; then
        echo "No log file available - sorry"
        exit 1
      else
        ls -al $LOG
        echo "-----------------------------------------------------"
        cat $LOG
        echo "-----------------------------------------------------"
      fi
      exit 0
      ;;
   "reboot")
      echo "------------------------------------------"
      echo "Rebooting in $THINK seconds"  
      echo "------------------------------------------"
      sleep $THINK
      echo "Rebooting NOW"
      echo "------------------------------------------"
      shutdown -r now
      exit 0
   ;;
   "halt")
      echo "------------------------------------------"
      echo "Shutdown in $THINK seconds"  
      echo "------------------------------------------"
      sleep $THINK
      echo "Shutting down NOW"
      echo "------------------------------------------"
      shutdown -h now
      exit 0
   ;;
   "kill")
      echo "------------------------------------------"
      echo "enigma2 will be restarted in $THINK seconds"
      echo "------------------------------------------"
      sleep $THINK
      echo "enigma2 will be restarted NOW"
      killall enigma2
      exit 0
   ;;
   "time")
      echo "------------------------------------------"
      echo "showing system time cron daemon is using"
      echo "------------------------------------------"
      date -u
      echo "------------------------------------------"
      echo "showing UTC time delta ER is using"
      echo "------------------------------------------"
      if [ ! -f $ERDELTA ]; then
         echo $ERDELTADEFAULT > $ERDELTA
      fi 
      cat $ERDELTA
      echo "------------------------------------------"
   ;;
   "delta")
      if [ $# = 1 ]; then
         echo "------------------------------------------"
         echo "No Timedelta passed, using 0"
         echo "------------------------------------------"
         echo "0" > $ERDELTA
      else
         echo "------------------------------------------"
         echo "changing UTC time delta to $2"
         echo "------------------------------------------"
         echo $2 > $ERDELTA
      fi   
   ;;
   "start")
echo "-----------------------------------------------------"
   echo "Starting Mediaserver dameon ..."
   $ERSTART start
echo "-----------------------------------------------------"
   exit 0
   ;;
   "stop")
echo "-----------------------------------------------------"
   echo "Stopping Mediaserver dameon ..."
   $ERSTART stop
echo "-----------------------------------------------------"
   exit 0
   ;;
   "restart")
echo "-----------------------------------------------------"
   echo "Restarting Mediaserver dameon ..."
   $ERSTART restart
echo "-----------------------------------------------------"
   exit 0
   ;;
   "info")
echo "-----------------------------------------------------"
echo "Check next line if Mediaserver dameon is running"
echo "-----------------------------------------------------"
ps ax | grep Mediaserver7025 |  grep python
echo "-----------------------------------------------------"
;;
   "enable")
      echo "-----------------------------------------------------"
      echo "Enabling / Updating ER ..."
         
         cd $ERHOME
         echo "Linking timers.xml"
         ln -sf /etc/enigma2/timers.xml $ERHOME/timers.xml
         echo "Enabling mediaserver startup on boot"
         ln -sf $MEDIASERVER/mediaserver.sh $ERSTART
         echo "Starting Mediaserver dameon ..."
         $ERSTART restart
         echo "Creating my own serviceref - reenable if changed Favourites"

         TIMERSTMP=$ERHOME/timers.tmp
         SERVICEREF=$ERHOME/serviceref.lst
         USERBOUQUET=/etc/enigma2/userbouquet.favourites.tv

         rm $TIMERSTMP > /dev/null 2>&1

         cp $USERBOUQUET $SERVICEREF
         dos2unix $SERVICEREF
         sed -ie s!"#SERVICE "!!g $SERVICEREF
         sed -ie s!"#NAME Favourites (TV)"!!g $SERVICEREF
         sed '/^[ 	]*$/d' < $SERVICEREF > $TIMERSTMP && mv $TIMERSTMP $SERVICEREF
         # now we have plain serviceref list !
#         chmod 755 $SERVICEREF>> /dev/null 2>&1
#         echo "Changing Owner of $ERHOME to nobody"
#         chown -R root $ERHOME
#         chgrp -R root $ERHOME
#         chmod -R 755 $ERHOME
      if [ ! -f $ERDELTA ]; then
         echo $ERDELTADEFAULT > $ERDELTA
      fi 
         echo "Restarting enigma so that config files are flushed"
         init 2
         sleep 5
         init 3
         echo "Finished enabling ER !"
         echo "-----------------------------------------------------"
;; 
   "disable")
      echo "-----------------------------------------------------"
         echo "Disabling ER ..."
   echo "Stopping Mediaserver dameon ..."
   $ERSTART stop
   cd /
   if [ -f /etc/rc3.d/$ERSTART ] ; then
      rm /etc/rc3.d/$ERSTART
   fi
   if  [ -d $PLUGINDIR/ER ]; then
   rm -r $PLUGINDIR/ER
   fi
   if  [ -d $ERHOME ]; then
        rm -r $ERHOME
   fi
         rm /etc/enigma2/timers.xml
         rm $ERSTART
         crontab -d

         echo "Deinstallation of ER finished !"
         echo "Restarting enigma to get rid of ER Plugin addon menu"
         killall enigma2
         echo "-----------------------------------------------------"
;;
    *)
        echo "-----------------------------------------------------"
	echo "Usage: $0 {info|time|stop|start|restart|reload|"
	echo "                       enable|disable|reboot|halt|kill|man}"
        echo "-----------------------------------------------------"
        echo "info       option displays info if Mediaserver is running"
        echo "time       option displays internal time used when recording"
        echo "delta      option to change internal UTC time delta in hours"
        echo "stop       option stops the Mediaserver dameon"
        echo "start      option starts the Mediaserver dameon"
        echo "restart    option restarts the Mediaserver dameon"
        echo "enable     option enables ER and Mediaserver daemon"
        echo "disable    option disables ER and Mediaserver daemon" 
        echo "reboot     option reboots Dreambox"
        echo "halt       option halts Dreambox"
        echo "kill       option will restart only enigma2"
        echo "man        option displays longer help text"
        echo "-----------------------------------------------------"
	exit 1
	;;
esac
