#!/bin/sh
VERSION=50
#
# written by thowi
#
# now record.sh is able to parse mediaserver requests which contain 
# recordstrings from www.tvbrowser.org
#
WHO=`whoami`

if  [ $WHO != "root" ]; then
    exit 0
fi
#wall $WHO



MEDIASERVER=/media/hdd/Mediaserver7025/Mediaserver7025
ERHOME=/usr/lib/enigma2/python/Plugins/Extensions/ER
ERDELTA=/usr/lib/enigma2/python/Plugins/Extensions/ER/.erdelta
DEFAULTNAME="ER Recording"
DEFAULTDESCRIPTION="planned by ER record script or WebIF from thowi"

PROGRAMC=$ERHOME/0_RECORDTIMER/1_RECORD_CHANNEL_
PROGRAMBH=$ERHOME/0_RECORDTIMER/1_RECORD_BEGIN_HOUR_
PROGRAMBM=$ERHOME/0_RECORDTIMER/1_RECORD_BEGIN_MINUTE_
PROGRAMEH=$ERHOME/0_RECORDTIMER/1_RECORD_END_HOUR_
PROGRAMEM=$ERHOME/0_RECORDTIMER/1_RECORD_END_MINUTE_
NEXTDAY=86400

TIMERS=/etc/enigma2/timers.xml
TIMERSTMP=$ERHOME/timers.tmp
RECORD=$ERHOME/record.sh
SERVICEREF=$ERHOME/serviceref.lst
USERBOUQUET=/etc/enigma2/userbouquet.favourites.tv
SHEDULE=$ERHOME/reload_sheduled

rm $TIMERSTMP > /dev/null 2>&1

cp $USERBOUQUET $SERVICEREF
dos2unix $SERVICEREF
sed -ie s!"#SERVICE "!!g $SERVICEREF
sed -ie s!"#NAME Favourites (TV)"!!g $SERVICEREF
sed '/^[ 	]*$/d' < $SERVICEREF > $TIMERSTMP && mv $TIMERSTMP $SERVICEREF
# now we have plain serviceref list !
chmod 755 $SERVICEREF>> /dev/null 2>&1

#
WEBCOMMAND=$ERHOME/lastwebcommand
REPEATED="0"
AFTEREVENT="nothing"
DISABLED="0"
JUSTPLAY="0"
# if nothing passed will record 2h
LATER=120
EIT="0"

if [ ! -f $ERDELTA ]; then 
   echo "0" > $ERDELTA
fi

ERDELTA=`cat $ERDELTA`
#echo "Timedelta to UTC $ERDELTA"
ERDELTASEC=`expr $ERDELTA "*" 3600`

# processing time
CDATE=`date -u`
CSEC=`date -u +'%s'`
CHOUR=`date -u +'%H'`
CMINUTE=`date -u +'%M'`
CMONTH=`date -u +'%m'`
CMONTHDAY=`date -u +'%d'`
CWEEKDAY=`date -u +'%w'`
#echo "Current time in seconds since 1970: $CSEC"
LSEC=`expr $LATER "*" 60`
#echo "Seconds in the Future $LSEC"
LSEC=`expr $LSEC "+" $CSEC`



echo "$1 $2 $3" >  $WEBCOMMAND
#wall "$1 $2 $3"
COMMAND="shell"
if [ ! `grep "HTTP/1" $WEBCOMMAND` ]; then
   # classic processing when interactively called
   COMMAND="shell"
else
   if [ ! `grep "TVBrowserTimerEvent.py" $WEBCOMMAND` ]; then
      COMMAND="unknown"
   else
      # only TVBrowserTimerEvent.py currently supported
      # get subcommand (only add and delete supported)
      COMMAND="TVBrowserTimerEvent"
   fi > /dev/null 2>&1
   ########### add further supported Funtions here !!!!!!!!!
fi > /dev/null 2>&1
#wall $COMMAND 
case $COMMAND in
"shell")
echo "No webcommand passed, hence using classic shell Processing"
# check for Channel 
if  [  ! $1 ]; then
    if [ -f $PROGRAMC* ]; then
       CHANNEL=`cat $PROGRAMC*`
    else
       echo "No Channel passed will use 1!"
       CHANNEL="1"
    fi
else
    CHANNEL=$1
fi
    echo "Channel for recording is $CHANNEL"

# check for begin
if  [  ! $2 ]; then
    if [ -f $PROGRAMC* ]; then
       BEGINH=`cat $PROGRAMBH*`
       BEGINM=`cat $PROGRAMBM*`
       if [ $BEGINH -lt 10 ]; then 
          BEGINH="0$BEGINH"
       fi
       if [ $BEGINM -lt 10 ]; then 
          BEGINM="0$BEGINM"
       fi
       BEGIN="$BEGINH:$BEGINM"
#       echo $BEGIN
       BEGIN=`date -d $BEGIN +'%s'`
       #
       # correct Time with UTC Delta
       #
       BEGIN=`expr $BEGIN "-" $ERDELTASEC`
       #
    else
       echo "No time passed for beginning recording using current time !"
       BEGIN=$CSEC
    fi
else
    BEGIN=`date -d $2 +'%s'`
       #
       # correct Time with UTC Delta
       #
       BEGIN=`expr $BEGIN "-" $ERDELTASEC`
       #
fi
echo "Time for beginning of record will be $BEGIN in epoch time"
# check for end
if  [  ! $3 ]; then
    if [ -f $PROGRAMC* ]; then
       ENDH=`cat $PROGRAMEH*`
       ENDM=`cat $PROGRAMEM*`
       if [ $ENDH -lt 10 ]; then 
          ENDH="0$ENDH"
       fi
       if [ $ENDM -lt 10 ]; then 
          ENDM="0$ENDM"
       fi
       END="$ENDH:$ENDM"
#       echo $END
       END=`date -d $END +'%s'`
       #
       # correct Time with UTC Delta
       #
       END=`expr $END "-" $ERDELTASEC`
       #
    else
       echo "No time passed for ending recording using begin time + 2h!"
       LSEC=`expr $LATER "*" 60`
       #echo "Seconds in the Future $LSEC"
       LSEC=`expr $LSEC "+" $BEGIN`
       END=$LSEC
    fi 
else
    END=`date -d $3 +'%s'`
       #
       # correct Time with UTC Delta
       #
       END=`expr $END "-" $ERDELTASEC`
       #
fi
#
# check if recording goes over midnight 
# END is lower then BEGIN because date is currently ignored via WebIF
#
if [ $END -lt $BEGIN ]; then
   END=`expr $END "+" $NEXTDAY`
fi
     
echo "Time for ending of record will be $END in epoch time"
# check for name
if  [  ! $4 ]; then
    NAME=$DEFAULTNAME
else
    NAME=$4
fi
# check for description
if  [  ! $5 ]; then
    DESCRIPTION=$DEFAULTDESCRIPTION
else
    DESCRIPTION=$5
fi
# only add timer possible
rm $ERHOME/0_RECORDTIMER/1_* > /dev/null 2>&1
COMMAND="add"
;;
"TVBrowserTimerEvent")

echo "TVBrowserTimer Event command passed, using www.tvbrowser.org processing" 
#wall "TVBrowserTimer Event command passed, using www.tvbrowser.org processing" 

#############################################################
sed -ie s!"&"!" "!g $WEBCOMMAND
sed -ie s!"GET /TVBrowserTimerEvent.py?command="!!g $WEBCOMMAND
sed -ie s!syear=!!g $WEBCOMMAND
sed -ie s!smonth=!!g $WEBCOMMAND
sed -ie s!sday=!!g $WEBCOMMAND
sed -ie s!shour=!!g $WEBCOMMAND
sed -ie s!smin=!!g $WEBCOMMAND
sed -ie s!eyear=!!g $WEBCOMMAND
sed -ie s!emonth=!!g $WEBCOMMAND
sed -ie s!eday=!!g $WEBCOMMAND
sed -ie s!ehour=!!g $WEBCOMMAND
sed -ie s!emin=!!g $WEBCOMMAND
sed -ie s!channel=!!g $WEBCOMMAND
# "" will be added later, use nothing in the meantime
# and remove leading Blank too
sed -ie s!descr=+!!g $WEBCOMMAND
sed -ie s!descr=!!g $WEBCOMMAND
sed -ie s!+!" "!g $WEBCOMMAND
sed -ie s!%3A!":"!g $WEBCOMMAND
# " are not possible causes just problems later - better use blank
#sed -ie s!%22!'"'!g $WEBCOMMAND
sed -ie s!%22!" "!g $WEBCOMMAND
# & are not possible causes just problems later - better use blank
sed -ie s!%26!" "!g $WEBCOMMAND
sed -ie s!%28!"("!g $WEBCOMMAND
sed -ie s!%29!")"!g $WEBCOMMAND
sed -ie s!%2C!","!g $WEBCOMMAND
sed -ie s!%C3%B6!""!g $WEBCOMMAND
sed -ie s!%C3%A4!""!g $WEBCOMMAND
sed -ie s!%C3%84!""!g $WEBCOMMAND
# \ will make problems using Blank
sed -ie s!%5C!" "!g $WEBCOMMAND
sed -ie s!" HTTP/1.1"!!g $WEBCOMMAND
# now webcommand should contain only raw data - let's move then to timers.xml
COMMANDSTRING=`cat $WEBCOMMAND`
#wall $COMMANDSTRING
#touch $WEBCOMMAND
rm $WEBCOMMAND > /dev/null 2>&1

COUNT=0
for ARGUMENT in $COMMANDSTRING ; do
#echo $ARGUMENT >> $WEBCOMMAND
case $COUNT in 
0)
COMMAND=$ARGUMENT
;;
1)
BEGINY=$ARGUMENT
;;
2)
BEGINT=$ARGUMENT
if [ $BEGINT -lt 10 ]; then 
     BEGINT="0$BEGINT"
fi
;;
3)
BEGIND=$ARGUMENT
if [ $BEGIND -lt 10 ]; then 
     BEGIND="0$BEGIND"
fi
;;
4)
BEGINH=$ARGUMENT
if [ $BEGINH -lt 10 ]; then 
     BEGINH="0$BEGINH"
fi
;;
5)
BEGINM=$ARGUMENT
if [ $BEGINM -lt 10 ]; then 
     BEGINM="0$BEGINM"
fi
;;
6)
ENDY=$ARGUMENT
;;
7)
ENDT=$ARGUMENT
if [ $ENDT -lt 10 ]; then 
     ENDT="0$ENDT"
fi
;;
8)
ENDD=$ARGUMENT
if [ $ENDD -lt 10 ]; then 
     ENDD="0$ENDD"
fi
;;
9)
ENDH=$ARGUMENT
if [ $ENDH -lt 10 ]; then 
     ENDH="0$ENDH"
fi
;;
10)
ENDM=$ARGUMENT
if [ $ENDM -lt 10 ]; then 
     ENDM="0$ENDM"
fi
;;
11)
CHANNEL=$ARGUMENT
;;
*)
NAME="$NAME $ARGUMENT"
;;
esac
COUNT=`expr $COUNT "+" 1`
done
DESCRIPTION=$DEFAULTDESCRIPTION
BEGIN="$BEGINT$BEGIND$BEGINH$BEGINM$BEGINY"
END="$ENDT$ENDD$ENDH$ENDM$ENDY"
BEGIN=`date -d $BEGIN +'%s'`
END=`date -d $END +'%s'`
#correct UTC time
BEGIN=`expr $BEGIN "-" $ERDELTASEC`
END=`expr $END "-" $ERDELTASEC`
;;
*)
echo "Unsupported command"
;;
esac



#wall $COMMAND

case $COMMAND in
"add")
#wall "adding to timers.xml"
# getting serrviceref
head -$CHANNEL $SERVICEREF | tail -n 1 - > $TIMERSTMP
SERVICEREF=`cat $TIMERSTMP`
echo "Serviceref is $SERVICEREF"
#
# create new timers.xml
# work locall because I don't have privileges
#

if [ ! -f $TIMERS ]; then
#wall  "$TIMERS doesn't exist, adding header"
   echo "$TIMERS doesn't exist, adding header"
   echo '<?xml version="1.0" ?>' > $TIMERS
   echo "<timers>" >> $TIMERS
else
#wall "$TIMERS exists already, removing header and tail"
#   echo "$TIMERS exists already, removing header and tail"
   sed -ie s!'<?xml version="1.0" ?>'!!g $TIMERS
   sed -ie s!"<timers>"!!g $TIMERS
   sed -ie s!"</timers>"!!g $TIMERS
   cp $TIMERS $TIMERSTMP
#   cat $TIMERSTMP
   echo '<?xml version="1.0" ?>' > $TIMERS
   echo "<timers>" >> $TIMERS
   cat $TIMERSTMP >> $TIMERS
   rm $TIMERSTMP
fi
echo '<timer begin="'$BEGIN'" end="'$END'" serviceref="'$SERVICEREF'" repeated="'$REPEATED'" name="'$NAME'" description="'$DESCRIPTION'" afterevent="'$AFTEREVENT'" eit="'$EIT'" disabled="'$DISABLED'" justplay="'$JUSTPLAY'">' >> $TIMERS
echo "</timer>"  >> $TIMERS
echo "</timers>"  >> $TIMERS
#cat $TIMERS
# removing empty lines
sed '/^[ 	]*$/d' < $TIMERS > $TIMERSTMP && mv $TIMERSTMP $TIMERS
;;
"delete")
#wall "deleting from timers.xml"

# delete command - I'm to lazy to remove from timers.xml,
# just change timer to 1 so that record is not done anymore
sed -ie s!$BEGIN!1!g $TIMERS
sed -ie s!$END!1!g $TIMERS
;;
*)
echo "unsupported command"
exit 1
;;
esac

init 2
init 3
rm $TIMERSTMP > /dev/null 2>&1

exit 0
